Subject: NEW RELATION - convertedfrom

From: Paul Hoffman <[email-masked]>
Date: Mon, 15 Dec 2014 16:22:31 -0800

Relation Name: convertedfrom

Description: Refers to a source from which this material was
converted.

Reference: draft-hoffman-xml2rfc

Notes: n/a

Application Data: n/a

---

From: Peter Williams <[email-masked]>
Date: Tue, 16 Dec 2014 07:44:30 -0700

How would this rel relate to the `alternate` and `original` rels. In what
situations would I use one vs the other?

Peter
Barelyenough.org
On Dec 15, 2014 6:26 PM, "Paul Hoffman" <[email-masked]> wrote:

> _______________________________________________
> link-relations mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/link-relations
>

---

From: Herbert Van de Sompel <[email-masked]>
Date: Tue, 16 Dec 2014 08:12:48 -0700

> situations would I use one vs the other?

"original" is a relation type that was specified for the Memento "web
time travel" framework. It points from a temporal snapshot of a
resource (capture in web archive, version resource in version
management system) to the resource that it is a snapshot of. See, for
example, http://www.mementoweb.org/guide/howto/

So, I don't think "original" is appropriate here. But I agree that
"alternate" could be.

Herbert

-- 
Herbert Van de Sompel
Digital Library Research & Prototyping
Los Alamos National Laboratory, Research Library
http://public.lanl.gov/herbertv/

==

---

From: Paul Hoffman <[email-masked]>
Date: Tue, 16 Dec 2014 08:23:32 -0800

> So, I don't think "original" is appropriate here. But I agree that

"alternate" is defined as "Refers to a substitute for this context". Saying that this thing was converted from that thing is quite different than saying that they are equivalent. We all know that some conversions are lossy, sometimes badly so.

--Paul Hoffman

---

From: Peter Williams <[email-masked]>
Date: Tue, 16 Dec 2014 10:33:57 -0700

Herbert,

Are you suggesting that it would be inappropriate to use the `original` rel
in any non-memento representation? If that is the intent the registry
should be updated to call out that narrowness of the acceptable use.

Personally, i would prefer a more expansive interpretation based on the
text in the registry. Ie, that the `original` link indicates that the
context was derived from the target. This would, obviously, include
mementos pointing to the resource of which they are snapshots, and would
also allow for converted documents to reference their originals and several
other potentially useful use cases.

Peter

---

From: Peter Williams <[email-masked]>
Date: Tue, 16 Dec 2014 11:33:39 -0700

Paul,

If the conversion is so lossy that it makes it conceptually different thing
(eg, creating thumbnail) then `alternate` might not be the best choice.
Otoh, if the conversions process goal is to produce an approximately
equivalent document (eg, raw to jpeg) then i think `alternate` is exactly
right. `alternate` does not imply that the target is a replacement for the
context in all situations or use cases but that it is a different
representation of the information.

Peter
barelyenough.org

On Tue, Dec 16, 2014 at 9:23 AM, Paul Hoffman <[email-masked]> wrote:
> "alternate" is defined as "Refers to a substitute for this context".
> Saying that this thing was converted from that thing is quite different
> than saying that they are equivalent. We all know that some conversions are
> lossy, sometimes badly so.
>
> --Paul Hoffman

---

From: Paul Hoffman <[email-masked]>
Date: Tue, 16 Dec 2014 10:42:59 -0800

On Dec 16, 2014, at 10:33 AM, Peter Williams <[email-masked]> wrote:
> If the conversion is so lossy that it makes it conceptually different thing (eg, creating thumbnail) then `alternate` might not be the best choice. Otoh, if the conversions process goal is to produce an approximately equivalent document (eg, raw to jpeg) then i think `alternate` is exactly right. `alternate` does not imply that the target is a replacement for the context in all situations or use cases but that it is a different representation of the information.

We disagree about what "alternate" means. I don't believe that "Refers to a substitute for this context" from the link relation registry is the same as your "approximately equivalent" above.

--Paul Hoffman

---

From: Herbert Van de Sompel <[email-masked]>
Date: Tue, 16 Dec 2014 12:00:20 -0700

On Tue, Dec 16, 2014 at 10:33 AM, Peter Williams <[email-masked]> wrote:
> in any non-memento representation? If that is the intent the registry should
> be updated to call out that narrowness of the acceptable use.
>

Yes, that is what I am suggesting: "original" is specific to the
Memento protocol, RFC 7089. I think the IANA registry already limits
the rel type to that context by stating:

"An Original Resource is a resource that exists or used to exist, and
for which access to one of its prior states may be required."

Herbert

> Personally, i would prefer a more expansive interpretation based on the text
> in the registry. Ie, that the `original` link indicates that the context was
> derived from the target. This would, obviously, include mementos pointing to
> the resource of which they are snapshots, and would also allow for converted
> documents to reference their originals and several other potentially useful
> use cases.
>
> Peter
>
>

==

---

From: Peter Williams <[email-masked]>
Date: Tue, 16 Dec 2014 13:01:54 -0700

> for which access to one of its prior states may be required."
That verbage seems rather too subtle to result in the behavior you desire.
Consider the situation where i have a resource that was created by
converting an "Original Resource" that "exists or used to exist" to a
different format. The last part of the sentence makes no sense in the
context the relation registry (so is easily ignored) and nowhere is it
clearly stated that one should avoid using this very generic sounding rel
outside a memento.

If we really don't have a rel for linking to an original (using the common
informal meaning of that word) I think we should have one. `convertedfrom`
seems somewhat too narrow and `alternate` misses the provenance aspect of
"original".

Peter
barelyenough.org

---

From: Herbert Van de Sompel <[email-masked]>
Date: Tue, 16 Dec 2014 13:06:43 -0700

> clearly stated that one should avoid using this very generic sounding rel

Thanks for that feedback. I am not sure what the procedure is to
change a registry entry but I will try to find out.

> seems somewhat too narrow and `alternate` misses the provenance aspect of

Does 'canonical' comes closer to what you want?

Herbert

==

---

From: Peter Williams <[email-masked]>
Date: Tue, 16 Dec 2014 13:59:08 -0700

> Does 'canonical' comes closer to what you want?

I don't think so. Consider a document that has been translated to a
different language, the translation would likely link to the original but
the original it not "preferred".

Peter
barelyenough.org

---

From: Herbert Van de Sompel <[email-masked]>
Date: Tue, 16 Dec 2014 16:56:32 -0700

On Dec 16, 2014, at 13:59, Peter Williams <[email-masked]> wrote:
> 
>> On Tue, Dec 16, 2014 at 1:06 PM, Herbert Van de Sompel <[email-masked]> wrote:
>> 
> I don't think so. Consider a document that has been translated to a different language, the translation would likely link to the original but the original it not "preferred".
> 

Understood. I was wondering whether "derivedfrom" would not be a term than convertedfrom? That would align with the term "derivation" that is used in W3C PROV (see http://www.w3.org/TR/prov-primer/#derivation-and-revision).

Herbert

---

From: Mark Nottingham <[email-masked]>
Date: Wed, 17 Dec 2014 17:30:29 +1100

FWIW -

My rule of thumb is that if it's a human understanding (i.e., fuzzy match) of semantics, we should be generous in determining what relations to use, so as to avoid creating too many slightly-different-but-mostly-the-same relation types. It's only when there's a protocol (i.e., machine implications) of semantic differences that it becomes important to split such hairs.

In other words, it's long been apparent that there are (at least) two kinds of link relations:

a) those that are human-intuative and eminently reusable; e.g., "self" "related" "describes" "describedby" "alternate"
b) those that are specific to a protocol, and the target resource usually has a well-defined interaction model; e.g., "memento" "stylesheet" "profile" "archive" "edit-form"

The former should be loosely defined and interpreted (with the aid of the context of their use); the latter should be strictly defined and interpreted.

In other other words, don't get stuck on the specific meaning of a link relation and create a new one unless you really, really need to.

YMMV.

> On 17 Dec 2014, at 5:42 am, Paul Hoffman <[email-masked]> wrote:
> 

--
Mark Nottingham   https://www.mnot.net/

---

From: Paul Hoffman <[email-masked]>
Date: Thu, 18 Dec 2014 14:10:23 -0800

> My rule of thumb is that if it's a human understanding (i.e., fuzzy match) of semantics, we should be generous in determining what relations to use, so as to avoid creating too many slightly-differ…

Your desire is understandable, but I think it falls down here. Someone reading a document that has a link that is marked as "alternate" could react differently than if they see a link marked "convertedFrom". You the reviewer might find them to be slightly-different-but-mostly-the-same, but someone looking at a document with those two might find them quite different. "alternate" could lead to "they're the same, and I have this other one cached, so I can ignore this", while "convertedFrom" would not have that action at all.

> The former should be loosely defined and interpreted (with the aid of the context of their use); the latter should be strictly defined and interpreted.

That seems fine, but "loosely" doesn't mean "with no context at all".

> In other other words, don't get stuck on the specific meaning of a link relation and create a new one unless you really, really need to.

I feel we need to here, given that the best alternative has a different meaning in the name and in the definition in the IANA registry.

> YMMV.

Does.

--Paul Hoffman

---

From: Mark Nottingham <[email-masked]>
Date: Fri, 19 Dec 2014 10:44:05 +1100

If you feel that you need to have a more precise relation defined, please do -- but make it precise enough so that it doesn't make people yet more unsure of which relation to use. 

Cheers,

> On 19 Dec 2014, at 9:10 am, Paul Hoffman <[email-masked]> wrote:
>

---

From: Paul Hoffman <[email-masked]>
Date: Thu, 18 Dec 2014 19:05:36 -0800

> If you feel that you need to have a more precise relation defined, please do -- but make it precise enough so that it doesn't make people yet more unsure of which relation to use. 

I believe my proposed value (convertedfrom) and the description ("refers to a source from which this material was converted") is precise, and differentiates well from "alternate".

--Paul Hoffman

---

From: Mark Nottingham <[email-masked]>
Date: Fri, 19 Dec 2014 14:14:17 +1100

*nod*

For bonus points, describe it using the terminology in RFC5988.

Cheers,

> On 19 Dec 2014, at 2:05 pm, Paul Hoffman <[email-masked]> wrote:
>

---

From: Herbert Van de Sompel <[email-masked]>
Date: Thu, 18 Dec 2014 20:55:02 -0700

> I believe my proposed value (convertedfrom) and the description ("refers to a source from which this material was converted") is precise, and differentiates well from "alternate".

And I would like to repeat my proposal to name the rel type derivedfrom to align with the W3C PROV notion of derivation. Which is really appropriate in this case, I think.

Herbert

---

From: Paul Hoffman <[email-masked]>
Date: Fri, 19 Dec 2014 08:31:54 -0800

> For bonus points, describe it using the terminology in RFC5988.

Whoops, yes. Please replace the text in my application with:

The target IRI points to a resource from which this material was converted.

(Although I noted that Section 6.2.2 is full of fragments, and I modeled on that, not on the better definitions currently in the registry.)

--Paul Hoffman